#pragma once

#include <map>

#include "opener_resource.h"



/* Collection types. */

typedef std::map<fileid_t, const char *> FilePaths;
typedef std::pair<fileid_t, const char *> FilePathEntry;



/* Support for providing access to files. */

class HostFileOpener : public OpenerResource
{
protected:
    FilePaths _paths;

    /* Configurable methods. */

    virtual fileid_t get_fileid(const char *path);

    virtual Accessor *make_accessor(fileid_t fileid);

public:
    explicit HostFileOpener(Pages *pages)
    : OpenerResource(pages)
    {
    }
};

// vim: tabstop=4 expandtab shiftwidth=4
