#pragma once

#include "pipe_accessor.h"
#include "pipe_object_interface.h"
#include "pipe_paging.h"
#include "pager.h"

/* A pager abstraction for a pipe. */

class PipePager : public Pager, public PipeObject
{
protected:
    PipePaging *_paging;
    bool _writing;

    /* Helper methods. */

    virtual long next_region_for_reader(offset_t *populated_size, offset_t *size);

    virtual long next_region_for_writer(offset_t *populated_size, offset_t *size);

public:
    explicit PipePager(PipePaging *paging, bool writer);

    virtual void close();

    /* Server details. */

    int expected_items();

    ipc_server_handler_type handler();

    void *interface()
    { return static_cast<PipeObject *>(this); }

    /* Pager methods. */

    virtual long map(offset_t offset, address_t hot_spot, flags_t flags, l4_snd_fpage_t *region);

    /* Pipe methods. */

    virtual long current_region(offset_t *populated_size, offset_t *size);

    virtual long next_region(offset_t *populated_size, offset_t *size);
};

// vim: tabstop=4 expandtab shiftwidth=4
